<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!--#include file="./globals.asp"-->
<html>
<head>
	<!-- (c) 2003 Sauly Software.  -->
	<link rel='stylesheet' href='./style/style.css' type='text/css' />
	<title>Save Result</title>
</head>

<body>
<h1><div align="center">Saving your vote(s)</div></h1>
<% if Debug="true" then %>
<hr>
<font size="-1"><strong>*Development comments hidden in live version*</strong><br>
This does the work based on the previous screen and then gives you a nice message then a button to go to the results page of this competition<br>
</font>
<hr>
<% end if %>

<br>
<center>

<%
	'Establish a connection with data source.  
	dim strSQL, cnn, intVoteCount, intComp_ID, strIPAddress, strVoterName, strVoterEmail
	dim intImageCount, intLoop, intScore, strComment, intVoter_ID, intImage_ID, boolVotedViaIP
  
  function fixstring(strIn)
		strIn = Replace(strIn, "'", "")		' get rid of pesky single quote
		strIn = Replace(strIn, chr(13), "")	' remove returns.
		strIn = Replace(strIn, chr(34), "")	' Pesky double quote
		fixstring = strIn
  end function
	
	function findVoterfromIP(strIP)
		' This tries to find the IP address in the voters table. If found, it returns the voter_ID
		' If not found, a voter_ID of zero is returned.
		dim rstVoter
		Set rstVoter = Server.CreateObject("ADODB.Recordset")
  	strSQL = "SELECT Voter_ID FROM [Voter] Where voter_IP='" & strIP & "'"
  	rstVoter.Open  strSQL, cnn
		if rstVoter.EOF then
			findVoterfromIP = 0
		else
			findVoterfromIP = rstVoter("Voter_ID") 
		end if
		rstVoter.Close
	end function
	
	function findifvotedfromIP(intVoter_ID, intComp_ID)
		' This returns "true" if the IP address has voted in the Comp_ID
		dim rstVoter
		Set rstVoter = Server.CreateObject("ADODB.Recordset")
  	strSQL = "SELECT * FROM [voter comps] Where voter_ID=" & intVoter_ID & " and Comp_ID=" & intComp_ID
  	rstVoter.Open  strSQL, cnn
		if rstVoter.EOF then
			findifvotedfromIP = "false"
		else
			findifvotedfromIP = "true" 
		end if
		rstVoter.Close
	end function
  
	'response.write "Your IP address is -- " & Request.ServerVariables("REMOTE_HOST")
	strIPAddress = Request.ServerVariables("REMOTE_HOST")
	strVoterName = "Unknown" ' for now...
	strVoterEmail = "Unknown"
	intVoteCount = 0
	boolVotedViaIP = "false"
	intComp_ID=request.form("fldComp_id")		' Get this from the previous form
	
	Set cnn = Server.CreateObject("ADODB.Connection")
	cnn.Open Connection
	
	intVoter_ID = findVoterfromIP(strIPAddress)
	if intVoter_ID=0 then
		' Record the voters IP
		strSQL = "INSERT INTO voter ( voter_IP, voter_name, voter_email )" &_
						 " 			VALUES 	( '" & strIPAddress & "','" & strVoterName & "','" & strVoterEmail & "')"
		cnn.Execute strSQL,,adCmdText + adExecuteNoRecords
		intVoter_ID = findVoterfromIP(strIPAddress)	'Look it up again.
	else
		' We know this IP address already. Do we need to check it?
		if IP_cheat_Check = "true" then
			'Have they voted yet, based on IP?
			boolVotedViaIP = findifvotedfromIP(intVoter_ID, intComp_ID)
		end if
	end if
	
	if intVoter_ID=0 then intVoter_ID=1		' Use the anon ID if all else fails.
	
	'Cycle through the forms results, and save a record if a vote or comment was made.
	if (Request.Cookies("Comp_" & intComp_ID)="true" and cookie_cheat_check = "true") or boolVotedViaIP="true" then
		'They have already voted for this comp. %>
		You have already voted in this comp. Your votes are discarded. Sorry! <br>
<%	
		if debug="true" then
			' Display reason for duplicate found..
			response.write "IP address of " & strIPAddress & " voted = " & boolVotedViaIP & "<br>"
			response.write "Cookie tracking voted = " & Request.Cookies("Comp_" & intComp_ID) & "<br>"
		end if
	else
		
		if request.form("ImageCount") then
			if Debug="true" then response.write request.form("ImageCount") & " Images on vote page <BR>"
			for intLoop = 1 to request.form("ImageCount")
				' Now get the values from the form.
				if Debug="true" then response.write "Processing image #" & intLoop & "<BR>"
				intScore = request.form("vote" & intLoop)
				if Debug="true" then response.write "Score =" & intScore & "<BR>"
				if isnull(request.form("comment" & intLoop)) then
					strComment = ""
				else
					strComment = fixstring(request.form("comment" & intLoop))
				end if
				if Debug="true" then response.write "Comment =" & strComment & "<BR>"
				intImage_ID = request.form("image_ID" & intLoop)
				if Debug="true" then response.write "Image_ID =" & intImage_ID & "<BR>"
				
				' If it's worth saving, do it.
				if intScore>0 or strComment<>"" and intImage_ID>0 then
					intVoteCount = intVoteCount + 1
					if Debug="true" then response.write "Seems worth saving<BR>"
					' At last! Save the damn vote already
					strSQL = "INSERT INTO vote ( voter_ID, image_ID, score, comment )" &_
								" 			VALUES 	( " & intVoter_ID & "," & intImage_ID & "," & intScore & ",'" & strComment & "')"
					if Debug="true" then response.write "The SQL to insert vote is " & strSQL & "<br>"
					cnn.Execute strSQL,,adCmdText + adExecuteNoRecords
				end if
			next
			if intVoteCount>0 then
				' Only set the cookie if they actually voted.
				Response.Cookies("Comp_" & intComp_ID) = "true"
				if Debug="true" then response.write "cookie expires on " & Dateadd("d",366,date()) & "<br>"
				' You can vote again in a years time...
				Response.Cookies("Comp_" & intComp_ID).Expires = Dateadd("d",366,date()) 
			end if
		end if
%>

<% 	if intVoteCount = 0 then %>
You did not vote as far as I can tell. Oh well!
<% 	elseif intVoteCount = 1 then %>
Your vote (or comment) has been saved!
<%		else%>
All of your votes (or comments) have been saved successfully.
<%		end if 

		cnn.close
		Set cnn = nothing
	end if %>
<br>
<br>
<input type="button" name="View" value="See All Results" 
	onClick="frmView.submit();">

<form action="result.asp" method="GET" name="frmView" id="frmView">
	<input type="hidden" name="fldComp_id" value='<%= intComp_ID %>'>
</form>

<br>
<br>
<br>
<!--#include file="./footer.asp"-->
</body>
</html>
