<!--

// ASP Web Database Interface Builder (http://www.awdib.com)
//  Handy Productions, 2002 - All Rights Reserved
// You may use all/part of this script in your own, non-competing
// projects on the condition that you leave this message in tact.

// Modified and commented. Renamed some generic variables. SWB 10-07-2003


function enterField(f1)
{
   f1.style.background='#FFFF91';	// Set to highligh on entry
}

function exitField(f1)
{
   f1.style.background='#FFFFFF'; // Reset to white on exit
}

function ValidateKey(f1,f2,f3,f4,f5)
{
   var key=window.event.keyCode;
   if (f3=='all')		// Exclude single, double quotes
   {
     var allowed='1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ :;,.?!$%^&*()_+-{}@~<>/';
   }
   if (f3=='a')	// Exclude numbers
   {
     var allowed='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ :;,.?!$%^&*()_+-{}@~<>';
   }
   else if (f3=='a_nospaces')	// Exclude Spaces and Symbols
   {
     var allowed='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_';
   }
	else if (f3=='grade')	// Exclude Spaces and Symbols, but allow slash for N/A
   {
     var allowed='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_/+';
   }
   else if (f3=='n')		// Real number
   {
     var allowed='0123456789.-';
   }
   else if (f3=='i')		// Integer
   {
     var allowed='0123456789';
   }
   else if (f3=='date')		// Integer
   {
     var allowed='0123456789/'; // Date
   }
	 else if (f3=='s')		// User passed string (f4)
   {
     var allowed=f4;
   }
   if (f3!='')
   {
      if (key!=13)
      {
         if (allowed.indexOf(String.fromCharCode(key))==-1)
         {
            key=0;
         }
      }
   }

   if (f3=='n'||f3=='i')
   {
      if (key==46)
      {
         if (f1.value.indexOf('.')>-1)
         {
            key=0;
         }
      }
   }


   if (f5=='u')
   {
      var newkey=String.fromCharCode(key).toUpperCase();
      key=newkey.charCodeAt(0);
   }
   else if (f5=='l')
   {
      var newkey=String.fromCharCode(key).toLowerCase();
      key=newkey.charCodeAt(0);
   }

   window.event.keyCode=key;
}


function ValidateField(f1,f2)
{
   if (document.frmMain.currentError.value!='')
   {
      if (document.frmMain.currentError.value!=f1.name)
      {
         //exitField(f1);
         return true;
      }
   }

   if (f1.value.length<f2)
   {
     if (f2==1)	// Get grammar right! SWB
	  {
	  		alert('This field must be at least 1 character long');
      }
	  else
	  {
      	alert('This field must be at least '+f2+' characters long');
      }
	  document.frmMain.currentError.value=f1.name;
      f1.focus();
      f1.select();
      return false;
   }
   else
   {
      // exitField(f1);
      document.frmMain.currentError.value='';
      return true;
   }
}

function ValidateNumber(f1,f2,f3,f4)
// f1=Number to check, f2=# decimal places allowed, f3=Minimum value, f4=Maximum value
{
   if (document.frmMain.currentError.value!='')
   {
      if (document.frmMain.currentError.value!=f1.name)
      {
         //exitField(f1);
         return true;
      }
   }

   if (f1.value=='')
   {
      alert('This value must be specified.');
      document.frmMain.currentError.value=f1.name;
      f1.focus();
      f1.select();
      return false;
   }


   if ((f3!=0||f4!=0))
   {
      if (f1.value<f3)
      {
         alert('Minimum value allowed is: '+f3);
         document.frmMain.currentError.value=f1.name;
         f1.focus();
         f1.select();
         return false;
      }
      else if (f1.value>f4)
      {
         alert('This value must be less than or equal to '+f4);
         document.frmMain.currentError.value=f1.name;
         f1.focus();
         f1.select();
         return false;
      }
   }

   var decimalpos=f1.value.indexOf('.');
   var fieldlen=f1.value.length;
   if (decimalpos>0)
   {
      if ((f2+1)<(fieldlen-decimalpos))
      {
        alert('Only '+f2+' decimal places allowed!');
        document.frmMain.currentError.value=f1.name;
        f1.focus();
        f1.select();
        return false;
      }
   }
   //exitField(f1);
   document.frmMain.currentError.value='';
   return true;
}

function ValidateSearchNumber(f1,f2,f3,f4)
{
   if (f1.value=='')
   {
      exitField(f1);
      return true;
   }
   else
   {
      return ValidateNumber(f1,f2,f3,f4);
   }

}


function ValidateDateTime(f1,f2,f3)
{
   if ((f3==0) & (f1.value.length==0))
   {
     exitField(f1);
     return true;
   }
   if (document.frmMain.currentError.value!='')
   {
      if (document.frmMain.currentError.value!=f1.name)
      {
         exitField(f1);
         return true;
      }
   }

   if (f1.value.length<12)
   {
      alert('Please enter date/time in format');
      document.frmMain.currentError.value=f1.name;
      f1.focus();
      f1.select();
      return false;
   }

   if (f2==1)
   {
      var dd=f1.value.substring(0,2);
      var mm=f1.value.substring(2,4);
      var yy=f1.value.substring(4,8);
   }
   else if (f2==0)
   {
      var mm=f1.value.substring(0,2);
      var dd=f1.value.substring(2,4);
      var yy=f1.value.substring(4,8);
   }
   else if (f2==2)
   {
      var yy=f1.value.substring(0,2);
      var mm=f1.value.substring(2,4);
      var dd=f1.value.substring(4,8);
   }

   if (dd>31)
   {
      alert('Day value must not be larger than 31!');
      document.frmMain.currentError.value=f1.name;
      f1.focus();
      f1.select();
      return false;
   }
   if (mm>12)
   {
      alert('Month must not be larger than 12!');
      document.frmMain.currentError.value=f1.name;
      f1.focus();
      f1.select();
      return false;
   }
   if (dd==30)
   {
      if (mm==4||mm==6||mm==9||mm==11)
      {
         alert('There is no 30th in Month '+mm);
         document.frmMain.currentError.value=f1.name;
         f1.focus();
         f1.select();
         return false;
      }
   }
   if (mm==2)
   {
      if (dd>29)
      {
         alert('There are not '+dd+' days in February!');
         document.frmMain.currentError.value=f1.name;
         f1.focus();
         f1.select();
         return false;
      }
      if (dd==29)
      {
         if (yy%4!=0)
         {
            alert('There are not 29 days in February of that year!');
            document.frmMain.currentError.value=f1.name;
            f1.focus();
            f1.select();
            return false;
         }
      }
   }

   var hh=f1.value.substring(8,10);
   var mm=f1.value.substring(10,12);
   if (hh>23)
   {
      alert('Hours can not be larger than 23!');
      document.frmMain.currentError.value=f1.name;
      f1.focus();
      f1.select();
      return false;
   }
   if (mm>59)
   {
      alert('[M13]!');
      document.frmMain.currentError.value=f1.name;
      f1.focus();
      f1.select();
      return false;
   }
   exitField(f1);
   document.frmMain.currentError.value='';
   return true;
}




function ValidateDate(f1,f2,f3)
{
   if ((f3==0) & (f1.value.length==0))
   {
     exitField(f1);
     return true;
   }
   if (document.frmMain.currentError.value!='')
   {
      if (document.frmMain.currentError.value!=f1.name)
      {
         exitField(f1);
         return true;
      }
   }

   if (f1.value.length<8)
   {
      alert('Please enter date/time in format');
      document.frmMain.currentError.value=f1.name;
      f1.focus();
      f1.select();
      return false;
   }

   if (f2==1)
   {
      var dd=f1.value.substring(0,2);
      var mm=f1.value.substring(2,4);
      var yy=f1.value.substring(4,8);
   }
   else if (f2==0)
   {
      var mm=f1.value.substring(0,2);
      var dd=f1.value.substring(2,4);
      var yy=f1.value.substring(4,8);
   }
   else if (f2==2)
   {
      var yy=f1.value.substring(0,2);
      var mm=f1.value.substring(2,4);
      var dd=f1.value.substring(4,8);
   }

   if (dd>31)
   {
      alert('Day value must not be larger than 31!');
      document.frmMain.currentError.value=f1.name;
      f1.focus();
      f1.select();
      return false;
   }
   if (mm>12)
   {
      alert('Month must not be larger than 12!');
      document.frmMain.currentError.value=f1.name;
      f1.focus();
      f1.select();
      return false;
   }
   if (dd==30)
   {
      if (mm==4||mm==6||mm==9||mm==11)
      {
         alert('There is no 30th in Month '+mm);
         document.frmMain.currentError.value=f1.name;
         f1.focus();
         f1.select();
         return false;
      }
   }
   if (mm==2)
   {
      if (dd>29)
      {
         alert('There are not '+dd+' days in February!');
         document.frmMain.currentError.value=f1.name;
         f1.focus();
         f1.select();
         return false;
      }
      if (dd==29)
      {
         if (yy%4!=0)
         {
            alert('There are not 29 days in February of that year!!');
            document.frmMain.currentError.value=f1.name;
            f1.focus();
            f1.select();
            return false;
         }
      }
   }
   exitField(f1);
   document.frmMain.currentError.value='';
   return true;
}

function ValidateTime(f1,f2,f3)
{
   if ((f3==0) & (f1.value.length==0))
   {
     exitField(f1);
     return true;
   }
   if (document.frmMain.currentError.value!='')
   {
      if (document.frmMain.currentError.value!=f1.name)
      {
         exitField(f1);
         return true;
      }
   }

   if (f1.value.length<4)
   {
      alert('Please enter time in format HHMM');
      document.frmMain.currentError.value=f1.name;
      f1.focus();
      f1.select();
      return false;
   }

   var hh=f1.value.substring(0,2);
   var mm=f1.value.substring(2,4);
   if (hh>23)
   {
      alert('Hours can not be larger than 23!');
      document.frmMain.currentError.value=f1.name;
      f1.focus();
      f1.select();
      return false;
   }
   if (mm>59)
   {
      alert('Minutes can not be larger than 59');
      document.frmMain.currentError.value=f1.name;
      f1.focus();
      f1.select();
      return false;
   }
   exitField(f1);
   document.frmMain.currentError.value='';
   return true;
}

function processClick(f1,f2,f3,f4)
{
   if (f1.checked)
   {
     f2.value=f3;
   }
   else
   {
     f2.value=f4;
   }
   return true;
}

-->
