<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!--#include file="./globals.asp"-->
<html>
<head>
	<!-- (c) 2003 Sauly Software.  -->
	<link rel='stylesheet' href='./style/style.css' type='text/css' />
	<title>Version History</title>
</head>

<body>
<h1><div align="center">Version History</div></h1>
<h3>Still To Do -</h3>
<ul>
<li>Nice header graphics</li>
<li>User upload images rather than administrator loading them.</li>
<li>Optional "blind voting" (can't see results until after you have voted)</li>
</ul>

<br>
<h3>Version 1.1.0 - Released 18th May 2004</h3>
<ul>
<li>Improved the way the default page (competitions) was calculated, specifically the leading image thumbnail. Previously, a lot of scores were totalled which could make the server very busy. Now it checks for a new field in the competitions table called "Winning_image" (text, 200 chars) which stops any counting for that comp. So, once the competition has closed, you can record the winning (front) image and stop it being dynamic. This could also be used to turn off the dynamic thumnail completely (to a fixed image). You could argue that seeing the leading image may influence voting. The admin forms have been updated to edit this new field, which means this code is incompatible with previous vote databases until the field is created. </li>
<li>Fixed a bug in the compedit.asp page where an ampersand (&) was missing is some of the code, which caused an error. Ooops. I think this error was introduced in version 1.0.1. Thanks Kamil.</li>
<li>Fixed a bug where "all" field validation excluded slashes. This is fine, except for when you have to put in some directory information where this is needed, such as in the imageedit.asp. Oh dear. Thanks Ben for pointing this out.</li>
</ul>

<h3>Version 1.0.1 - Release 25th Feb 2004</h3>
<ul>
<li>Fixed a bug where some users could not see the competitions (default) page. This was due to a date format issue. (Thanks Arnold)</li>
<li>Fixed a bug where the button to see results after just voting was not right. This problem was introduced last version, when I change the POST to a GET. I forgot to change this one also. Ooops. Oh well, done now.</li>
<li>Added a sort order to the voting & comp edit so that it is sorted by image name.</li>
<li>Made the Full images appear in a new window, which should stop timout issues when voting. (Thanks Johan!)</li>
</ul>

<h3>Version 1.0.0 - Released 2nd Jan 2004</h3>
<ul>
<li><strong><font color="green">Major Change.</font></strong> Added full web based administration forms. Password protected. You now no longer need to use MS Access to edit anything. If you combine this with FTP or some other remote access to the images directory, the whole show can be administered remotely. At the very least, for most people, using IE to configure the software is more intuitive than placing manual entries in Access tables. I have been meaning to do this for a long time, not because I need it (I am OK with manual table hacking!) but because I think it's an important step in making the software truly usable by non-programmers. With this done, and 5 months of real world usage (and debugging), I am prepared to call this version 1.0.0!<br><br></li>
<li>Modified the Competitions screen to show the thumbnail of the leading image, which will also take you to the results if clicked on. This makes the competitions listing a bit more interesting and pictorial. It gives it a bit more oomph, although the overall site design is still fairly plain.</li>
<li>Modified the FAQ, added some questions. Changed some answers slightly.</li>
<li>Modified the form processing method from POST to GET for the competition results page and single image results page. This allows these pages to be bookmarked. This makes the URL's less "clean", but hey, I don't think most people care about this. They just want to bookmark stuff. Note that you can not bookmark the voting pages, which is consitent with the policy of discouraging multiple voting (even though this would not work anyway).</li>
<li>Fixed a bug where the results page would crash if there were no comments yet for any pictures in the whole competition.</li>
<li>Fixed a very minor visual bug with the anti-aliasing on the medals graphics. They now don't have white spots around them. It's a small thing, but it was really annoying me!</li>
</ul>

<h3>Version 0.1.0 - Released 12th Oct 2003</h3>
<ul>
<li>More multi-vote tracking, based on IP. New query "voter comps". Not compatible with previous database (until this query exists).</li>
<li>Fixed a bug where voting stopped at the start of the last day, rather than the end of it.</li>
<li>Fixed a bug where you could re-vote in two days rather than in 2 years. Doh! Not my fault! Not my Fault..!</li>
<li>Fixed a bug where a 'Return' or 'Enter' keypress in the comments text area of the voting form submitted the form. This is default browser behaviour, not my doing. It now moves you to the next image text field, or if it is the last back up to the first.</li>
<li>Nicer looking table in comp screen</li>
<li>Small changes to database (comp list ordering)</li>
<li>Cosmetic changes to the vote and result layouts (horizontal rule, result table in header, slightly wider)</li>
<li>Changed sample images to those I have copyright over, and included full image size (which makes the download for this version larger, but shows better how it should be used).</li>
</ul>

<h3>Version 0.0.2 - Released 23rd Aug 2003</h3>
<ul>
<li>Enables you to view all comments for a single image if they have been truncated.</li>
<li>Sorts comments so that the most recent are at the top (and less likely to be truncated)</li>
<li>Minor changes to the database indexes.</li>
<li>Minor changes to FAQ and text/layout on other pages.</li>
<li>Fixed some spelling mistakes.</li>
<li>Added "go back" buttons to most forms.</li>
<li>Added a bit more information on the paypal system/shareware fees.</li>
</ul>

<h3>Version 0.0.1 - Released 17th Aug 2003</h3>
<ul>
<li>Comps based on dates, auto close off for voting.</li>
<li>Comp Status column completed, including hyperlink to image upload area. Could still be colored.</li>
<li>Improved the About to split into version history and FAQ</li>
<li>Added checks to see if you have voted already in both the results save and comps list.</li>
<li>Added hyperlink to larger picture in voting screen and results, if available.</li>
</ul>
<br>
<div align="center"><input type="button" name="back" onClick="history.go(-1);" value="Go Back"></div>
<br>

<!--#include file="./footer.asp"-->
</body>
</html>